"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.GetFieldValueFromFirebaseInstance = exports.serverTimestamp = exports.getFunctions = exports.getFieldValue = exports.getFirestore = exports.firestoreRef = exports.getFirebase = exports.emailProvider = exports.githubProvider = exports.googleProvider = exports.justFirebase = exports.getFirebaseAuth = exports.initializeFirebase = exports.getFirebaseConfig = exports.GetEnvironment = exports.setFirebaseConfig = exports.firebaseConfigs = exports.FirebaseEnvironments = exports.FireComponent = void 0;
const firebase_1 = __importDefault(require("firebase"));
const react_firebaseui_1 = require("react-firebaseui");
const Common = __importStar(require("./Common"));
const path = __importStar(require("path"));
const dotenv_1 = __importDefault(require("dotenv"));
if (!process.env.NODE_ENV || process.env.NODE_ENV === "development") {
    dotenv_1.default.config({ path: path.resolve(__dirname + '../../../.env') });
}
exports.FireComponent = react_firebaseui_1.FirebaseAuth;
var FirebaseEnvironments;
(function (FirebaseEnvironments) {
    FirebaseEnvironments["development"] = "development";
    FirebaseEnvironments["qa"] = "qa";
    FirebaseEnvironments["production"] = "production";
})(FirebaseEnvironments = exports.FirebaseEnvironments || (exports.FirebaseEnvironments = {}));
exports.firebaseConfigs = {
    [FirebaseEnvironments.development]: {
        apiKey: "AIzaSyAus_ACzfASXnKQPBNPFdsApkuUbiQGsvE",
        authDomain: "coalesce-a6346.firebaseapp.com",
        projectId: "coalesce-a6346",
        storageBucket: "coalesce-a6346.appspot.com",
        messagingSenderId: "236763625216",
        appId: "1:236763625216:web:8495f0a13152e1d63c25e5",
        measurementId: "G-DPT4YWV78T"
    },
    [FirebaseEnvironments.qa]: {
        apiKey: "AIzaSyDmn_9ToPIXVBzjTdyj1wny9XivH-g48T0",
        authDomain: "cls-qa.firebaseapp.com",
        projectId: "cls-qa",
        storageBucket: "cls-qa.appspot.com",
        messagingSenderId: "243490689213",
        appId: "1:243490689213:web:29972e04747e7d113b67d4",
        measurementId: "G-FRJ2PNVPT4"
    },
    [FirebaseEnvironments.production]: {
        apiKey: "AIzaSyAGVrKvXxw69cVVdlQ7NMa46rQyrM3GuJM",
        authDomain: "dev-etl-284121.firebaseapp.com",
        projectId: "dev-etl-284121",
        storageBucket: "dev-etl-284121.appspot.com",
        messagingSenderId: "96686924891",
        appId: "1:96686924891:web:4d9a88b3b69f7865084b7e",
        measurementId: "G-33CRZMHDGR"
    }
};
const setFirebaseConfig = (environment) => {
    return exports.firebaseConfigs[environment];
};
exports.setFirebaseConfig = setFirebaseConfig;
const GetEnvironment = () => {
    var _a;
    if (Common.isCommandLine()) {
        // need to track down why this naming is inconsistent
        return process.env.RUNTIME_ENVIRONMENT || process.env.NODE_ENVIRONMENT || FirebaseEnvironments.production;
    }
    else {
        // having a default value here allows Cypress component tests to run properly
        return (_a = window.ENVIRONMENT) !== null && _a !== void 0 ? _a : FirebaseEnvironments.development;
    }
};
exports.GetEnvironment = GetEnvironment;
const getFirebaseConfig = () => {
    //Environment is located in public/config.js if a quick change is needed or if backend env var, set in Kubernetes
    const environment = (0, exports.GetEnvironment)();
    return (0, exports.setFirebaseConfig)(environment);
};
exports.getFirebaseConfig = getFirebaseConfig;
const initializeFirebase = () => {
    if (!firebase_1.default.apps.length) {
        firebase_1.default.initializeApp((0, exports.getFirebaseConfig)());
    }
    else {
        firebase_1.default.app(); // if already initialized, use that one
    }
};
exports.initializeFirebase = initializeFirebase;
const getFirebaseAuth = () => firebase_1.default.auth();
exports.getFirebaseAuth = getFirebaseAuth;
exports.justFirebase = firebase_1.default;
exports.googleProvider = firebase_1.default.auth.GoogleAuthProvider.PROVIDER_ID;
exports.githubProvider = firebase_1.default.auth.GithubAuthProvider.PROVIDER_ID;
exports.emailProvider = firebase_1.default.auth.EmailAuthProvider.PROVIDER_ID;
const getFirebase = () => firebase_1.default.app();
exports.getFirebase = getFirebase;
exports.firestoreRef = firebase_1.default.firestore.DocumentReference;
const getFirestore = () => firebase_1.default.app().firestore();
exports.getFirestore = getFirestore;
const getFieldValue = () => firebase_1.default.firestore.FieldValue;
exports.getFieldValue = getFieldValue;
const getFunctions = () => firebase_1.default.app().functions();
exports.getFunctions = getFunctions;
exports.serverTimestamp = firebase_1.default.firestore.FieldValue.serverTimestamp();
const GetFieldValueFromFirebaseInstance = (firebase) => {
    let fieldValue = firebase.firestore.FieldValue;
    if (!fieldValue) {
        fieldValue = (0, exports.getFieldValue)();
    }
    return fieldValue;
};
exports.GetFieldValueFromFirebaseInstance = GetFieldValueFromFirebaseInstance;
//# sourceMappingURL=Firebase.js.map