"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getAccessToken = exports.runRefresh = exports.GetAllStepsForJob = exports.getOnRunResult = exports.runDeploy = exports.createReduxStore = exports.getRunInfoRef = exports.getRunResultsCollectionRef = exports.updateRunResult = exports.addToRunHistory = exports.EndRun = exports.updateRun = exports.addNewRun = exports.getRunStatusAdmin = exports.getRunRunResultsCollection = exports.getRun = exports.getRunsCollectionLimited = exports.getRunsCollection = exports.getNextRunCounter = void 0;
const CommonOperations = __importStar(require("./CommonOperations"));
const Runner = __importStar(require("./Runner"));
const StepTypes = __importStar(require("./StepTypes"));
const State = __importStar(require("./State"));
const Logging = __importStar(require("./Logging"));
const redux_1 = require("redux");
const _1 = require(".");
const GraphOperations = __importStar(require("./GraphOperations"));
const RunStepHelpers = __importStar(require("./RunStepHelpers"));
const immer = __importStar(require("immer"));
const Search = __importStar(require("./Search"));
const Common = __importStar(require("./Common"));
const getNextRunCounter = (firestore, orgConfigDocRef) => {
    return CommonOperations.getNextCounter(firestore, orgConfigDocRef, 'runCounter', 1);
};
exports.getNextRunCounter = getNextRunCounter;
const getRunsCollection = (firestore, teamID) => {
    return CommonOperations.getOrgDataDocRefAdmin(firestore, teamID).collection('runs');
};
exports.getRunsCollection = getRunsCollection;
const getRunsCollectionLimited = (firestore, teamID, field, limit) => {
    return (0, exports.getRunsCollection)(firestore, teamID).orderBy(field, 'desc').limit(limit);
};
exports.getRunsCollectionLimited = getRunsCollectionLimited;
const getRun = (firestore, teamID, runID) => {
    return (0, exports.getRunsCollection)(firestore, teamID).where("id", "==", runID);
};
exports.getRun = getRun;
const getRunRunResultsCollection = (firestore, teamID, runID) => {
    return (0, exports.getRunsCollection)(firestore, teamID).doc(runID).collection('runResults');
};
exports.getRunRunResultsCollection = getRunRunResultsCollection;
const getRunStatusAdmin = (firestore, teamID, runID) => {
    return (0, exports.getRunsCollection)(firestore, teamID).doc(runID.toString());
};
exports.getRunStatusAdmin = getRunStatusAdmin;
const addNewRun = (firebase, teamID, runCounter, startingState) => {
    const firestore = firebase.firestore();
    const runsCollectionRef = (0, exports.getRunsCollection)(firestore, teamID);
    let fieldValue = firebase.firestore.FieldValue;
    if (fieldValue === undefined) {
        fieldValue = _1.Firebase.getFieldValue();
    }
    return runsCollectionRef.doc(runCounter.toString()).set(Object.assign(Object.assign({}, startingState), { runStartTime: fieldValue.serverTimestamp(), runHeartbeat: fieldValue.serverTimestamp() }));
};
exports.addNewRun = addNewRun;
const updateRun = (firestore, teamID, runCounter, newState) => {
    const runsCollectionRef = (0, exports.getRunsCollection)(firestore, teamID);
    return runsCollectionRef.doc(runCounter.toString()).set(newState, { merge: true });
};
exports.updateRun = updateRun;
const EndRun = (firebase, teamID, runCounter, newState) => {
    const firestore = firebase.firestore();
    let fieldValue = firebase.firestore.FieldValue;
    if (fieldValue === undefined) {
        fieldValue = _1.Firebase.getFieldValue();
    }
    const newStateWithEndTime = Object.assign(Object.assign({}, newState), { runEndTime: fieldValue.serverTimestamp() });
    return (0, exports.updateRun)(firestore, teamID, runCounter, newStateWithEndTime);
};
exports.EndRun = EndRun;
const addToRunHistory = (firebase, teamID, runCounter, stepCounter) => {
    let fieldValue = firebase.firestore.FieldValue;
    //admin firebase has more associated with it that a singular firebase app instance (which is what the onPrem solution passes around)
    if (fieldValue === undefined) {
        fieldValue = _1.Firebase.getFieldValue();
    }
    return (0, exports.getRunInfoRef)(firebase.firestore(), teamID, runCounter).update({
        runHistory: fieldValue.arrayUnion(stepCounter)
    });
};
exports.addToRunHistory = addToRunHistory;
const updateRunResult = (firestore, teamID, runCounter, stepCounter, runResult) => {
    const runResultsListCollection = (0, exports.getRunResultsCollectionRef)(firestore, teamID, runCounter);
    return runResultsListCollection.doc(stepCounter.toString()).set(runResult);
};
exports.updateRunResult = updateRunResult;
const getRunResultsCollectionRef = (firestore, teamID, runCounter) => {
    return (0, exports.getRunInfoRef)(firestore, teamID, runCounter).collection("runResults");
};
exports.getRunResultsCollectionRef = getRunResultsCollectionRef;
const getRunInfoRef = (firestore, teamID, runCounter) => {
    const runsCollectionRef = (0, exports.getRunsCollection)(firestore, teamID);
    return runsCollectionRef.doc(runCounter.toString());
};
exports.getRunInfoRef = getRunInfoRef;
const createReduxStore = (firestore, startingData, userCredentials, teamInfo, workspaceID, extraStepData) => {
    const reduxData = startingData;
    let myMiddleware = [State.myMiddleware[0]]; //just the thunk, no logging
    let store = State.CreateStore(State.myAppReducers(), {}, redux_1.compose, myMiddleware, [], () => { });
    Object.keys(reduxData.steps).forEach((stepCounter) => {
        const stepData = reduxData.steps[stepCounter];
        store.dispatch(State.getCreateStepAction(stepData.operation, 1, stepCounter, stepData.name, false, 0, 0));
    });
    Object.keys(reduxData.macros).forEach(macroCounter => {
        const macroData = reduxData.macros[macroCounter];
        store.dispatch({ type: "CREATE_macros", id: macroCounter, value: macroData });
    });
    Object.keys(reduxData.stepTypes).forEach(templateCounter => {
        var _a;
        const stepTypeData = reduxData.stepTypes[templateCounter];
        const stepTypeDataParsed = StepTypes.parseStepTypeYAML(reduxData.stepTypes, templateCounter);
        store.dispatch({ type: "CREATE_templates", id: templateCounter, value: stepTypeData });
        // only add the parsed version if it actually parses correctly
        if (!((_a = stepTypeDataParsed.metadata.error) === null || _a === void 0 ? void 0 : _a.errorString)) {
            store.dispatch({ type: "CREATE_templates_parsed", id: templateCounter, value: stepTypeDataParsed });
        }
    });
    //pass in additional data to the store in the event it is not included to the reduxData.steps
    if (extraStepData) {
        Object.keys(extraStepData).forEach((stepCounter) => {
            const stepData = extraStepData[stepCounter];
            store.dispatch(State.getCreateStepAction(stepData.operation, 1, stepCounter, stepData.operation.name, false, 0, 0));
        });
    }
    if (reduxData.userConnections) {
        Object.keys(reduxData.userConnections).forEach(workspaceID => {
            const connectionData = reduxData.userConnections[workspaceID];
            if (!connectionData)
                return;
            Object.keys(connectionData).forEach(userID => {
                store.dispatch({
                    type: State.getCreateEntityActionString(State.DocRefs.users),
                    id: userID,
                    environmentID: workspaceID,
                    value: connectionData[userID]
                });
            });
        });
    }
    const projectsSafe = Common.getValueSafe(reduxData, ["projects"], {});
    Object.keys(projectsSafe).forEach((projectID) => {
        const projectData = projectsSafe[projectID];
        store.dispatch(State.getAddProjectAction(projectID, projectData));
    });
    const packagesSafe = Common.getValueSafe(reduxData, ["packages"], {});
    Object.keys(packagesSafe).forEach((packageID) => {
        const packageData = packagesSafe[packageID];
        store.dispatch(State.getAddPackageAction(packageID, packageData));
    });
    store.dispatch(State.getBulkUpdateConfigAction(workspaceID, userCredentials));
    store.dispatch(State.getBulkEditWorkspaces(startingData.workspaces));
    store.dispatch(State.getChangeWorkspace(workspaceID));
    store.dispatch(State.fbLogin(teamInfo));
    // store.dispatch(State.setAdminTeam(teamID))
    return store;
};
exports.createReduxStore = createReduxStore;
const runDeploy = (firebase, teamInfo, runCounter, runInfo, RunSQL, userContext) => {
    const teamID = teamInfo.fbTeamID;
    const logContext = {
        orgID: teamID,
        userID: teamInfo.fbUserID,
        envID: runInfo.runDetails.environmentID
    };
    const fullLogContext = {
        logContext,
        runCounter
    };
    _1.RunnerOperations.DeployLogWithPrefix(fullLogContext).info(`runDeploy firebase:${firebase.name}, runInfo:`, runInfo);
    const runDetails = runInfo.runDetails;
    const dividedStepDataWithWorkspaceEdits = runInfo.runDetails.dividedStepDataWithWorkspaceEdits;
    /** CD-751 */
    //in order to let this code path work, we need the deleted step data passed into the redux store in order to run runSteps appropriately since it assumes whatever you're running exists and has data
    const reduxStore = (0, exports.createReduxStore)(firebase.firestore(), runInfo.runDetails.fromWorkspaceData, runInfo.userCredentials, teamInfo, runInfo.runDetails.toWorkspaceID, dividedStepDataWithWorkspaceEdits.deletedTable);
    /**
     *
     * @param stepDataWithWorkspaceEdits
     * @param isDelete flag for describing the type of run being enacted. If isDelete is true, that means we will be iterating over steps that didn't have data in the reduxStore, so we know to wipe their firestore data when we reach Runner.runStep.then()
     * @returns
     */
    const runSteps = (stepDataWithWorkspaceEdits, isDelete) => {
        return new Promise((resolve, reject) => {
            try {
                const stepsWithEdits = Object.keys(stepDataWithWorkspaceEdits);
                const dispatch = reduxStore.dispatch;
                const getState = reduxStore.getState;
                const initializeCB = (stepID) => (0, exports.addToRunHistory)(firebase, teamID, runCounter, stepID);
                const updateCB = (stepID) => (0, exports.updateRunResult)(firebase.firestore(), teamID, runCounter, stepID, reduxStore.getState().runResults[stepID]);
                const dependenciesLookup = GraphOperations.getDependenciesLookup(runDetails.fromWorkspaceData.steps);
                const processNext = () => {
                    const runResults = getState().runResults;
                    let allComplete = true;
                    stepsWithEdits.forEach(stepCounter => {
                        var _a;
                        const runState = (_a = runResults[stepCounter]) === null || _a === void 0 ? void 0 : _a.runState;
                        if (runState === "running" || runState === "queued" || runState === "waiting") {
                            allComplete = false;
                        }
                    });
                    if (allComplete) {
                        _1.RunnerOperations.DeployLogWithPrefix(fullLogContext).info(`steps finished in runStep`);
                        let hasError = false;
                        stepsWithEdits.forEach(stepCounter => {
                            const runResult = runResults[stepCounter];
                            const runState = runResult === null || runResult === void 0 ? void 0 : runResult.runState;
                            if (runState === _1.RunnerOperations.RunResultsRunState.error) {
                                hasError = true;
                            }
                        });
                        if (hasError) {
                            reject("A Node exited with an Error");
                        }
                        else {
                            resolve();
                        }
                        return;
                    }
                    stepsWithEdits.forEach(stepCounter => {
                        var _a;
                        const runState = (_a = runResults[stepCounter]) === null || _a === void 0 ? void 0 : _a.runState;
                        const isCompleteOrRunning = runState === _1.RunnerOperations.RunResultsRunState.complete || runState === _1.RunnerOperations.RunResultsRunState.running || runState === _1.RunnerOperations.RunResultsRunState.error;
                        if (isCompleteOrRunning) {
                            _1.RunnerOperations.DeployLogWithPrefix(fullLogContext).info("completed or running already", stepCounter);
                            return;
                        }
                        else {
                            _1.RunnerOperations.DeployLogWithPrefix(fullLogContext).info("not done:", stepCounter);
                        }
                        let allDependenciesReady = true;
                        const dependencies = dependenciesLookup[stepCounter] || []; //when deleted, there are no dependencies from the lookup?
                        dependencies.forEach(dep => {
                            var _a;
                            if (!(stepsWithEdits.includes(dep.toString()))) {
                                _1.RunnerOperations.DeployLogWithPrefix(fullLogContext).info("step didnt need to run, no edits: ", stepCounter, "dep", dep);
                            }
                            else {
                                const dependencyStatus = (_a = runResults[dep]) === null || _a === void 0 ? void 0 : _a.runState;
                                _1.RunnerOperations.DeployLogWithPrefix(fullLogContext).info("dependency status: ", dependencyStatus);
                                if (dependencyStatus === "queued" || dependencyStatus === "running" || dependencyStatus === "waiting") {
                                    allDependenciesReady = false;
                                }
                            }
                        });
                        if (allDependenciesReady) {
                            _1.RunnerOperations.DeployLogWithPrefix(fullLogContext).info("running step: ", stepCounter);
                            const stepDataWithEdits = stepDataWithWorkspaceEdits[stepCounter];
                            const workspaceEdits = stepDataWithEdits.workspaceEdits;
                            const allMacros = Object.assign(Object.assign({}, getState().macros), _1.MacroOperations.refMacroDefinitions);
                            const workspaceID = _1.Workspaces.getCurrentWorkspace(reduxStore.getState());
                            const templateParams = {
                                userContext,
                                nodeMetadata: stepDataWithEdits.nodeMetadata,
                                macrosString: _1.MacroOperations.getAllMacros(allMacros),
                                templateString: ""
                            };
                            _1.RunnerOperations.DeployLogWithPrefix(fullLogContext).info("running step: ", workspaceEdits);
                            const cleanTemplateParamsCopy = _1.RunnerOperations.GetSecureCopyForLog(templateParams);
                            const secureCopyForLogging = Object.assign(Object.assign({}, cleanTemplateParamsCopy), { userContext: _1.RunnerOperations.CleanIUserContextForLogging(userContext) });
                            _1.RunnerOperations.DeployLogWithPrefix(fullLogContext).info("template params:", secureCopyForLogging);
                            /** CD-752 update to move teamID out of context after we move the auth reducer to State.ts  */
                            // RunnerOperations.DeployLogWithPrefix(Logging.LogLevel.info, c, `step: ${s}, template params: ${RunnerOperations.GetSecureTemplateParamsForLog(templateParams)}`)
                            const executor = RunStepHelpers.GetDeployExecutor(workspaceEdits, templateParams, stepCounter, initializeCB, updateCB, getState(), RunSQL);
                            dispatch(Runner.RunStep(stepCounter, executor)).then((result) => {
                                _1.RunnerOperations.DeployLogWithPrefix(fullLogContext).info("runStep promise complete for step", stepCounter, "; updating firestore; isDelete?:", isDelete);
                                //update firestore after a success
                                let firestorePromise;
                                if (isDelete) {
                                    firestorePromise = _1.Workspaces.deleteStepAdmin(firebase, teamID, runDetails.toWorkspaceID, stepCounter);
                                }
                                else {
                                    /**
                                     * UPDATE for CD-1684
                                     * Need to embed two new values into the operation
                                     * database
                                     * schema
                                     * Taken from the 'deployedMappings' data so that in the event of a deploy
                                     * failure, we still have the knowledge of where each node lives, at the
                                     * granularity of the node level, so we can successfully deploy afterwards
                                     * despite the failure, specifically if we deploy a different commit which
                                     * involves changes to the nodes that succeeded in the previous deploy
                                     */
                                    const stepData = runDetails.fromWorkspaceData.steps[stepCounter];
                                    const locationID = stepData.operation.locationID;
                                    let locations;
                                    let database;
                                    let schema;
                                    let newStepData = stepData.operation;
                                    try {
                                        if (templateParams.nodeMetadata.mapping) {
                                            locations = templateParams.nodeMetadata.mapping;
                                            database = locations[locationID].database;
                                            schema = locations[locationID].schema;
                                            newStepData = immer.produce(stepData.operation, draftState => {
                                                draftState["database"] = database;
                                                draftState["schema"] = schema;
                                            });
                                            _1.RunnerOperations.DeployLogWithPrefix(fullLogContext).info("newStepData for firestore promise", newStepData);
                                        }
                                    }
                                    catch (error) {
                                        const logger = Logging.GetLogger(Logging.LoggingArea.Deploy);
                                        const errorMessage = `Error attempting to update the database/schema on deployed nodeID ${stepCounter}: ${newStepData === null || newStepData === void 0 ? void 0 : newStepData.name}, locations: ${locations} error: ${error}`;
                                        logger.emergContext(logContext, errorMessage);
                                        throw new Error(errorMessage);
                                    }
                                    firestorePromise = _1.Workspaces.setStepAdmin(firebase, teamID, runDetails.toWorkspaceID, stepCounter, newStepData);
                                }
                                return firestorePromise.then(() => {
                                    _1.RunnerOperations.DeployLogWithPrefix(fullLogContext).info(`step:${stepCounter} finished in runStep`);
                                    processNext();
                                }).catch(error => {
                                    _1.RunnerOperations.DeployLogWithPrefix(fullLogContext).error(`Error setting firebase for step ${stepCounter}:`, error);
                                    throw new Error(`Failed to set firebase for step: ${teamID}, ${runDetails.toWorkspaceID}, ${stepCounter}`);
                                });
                            }).catch((error) => {
                                _1.RunnerOperations.DeployLogWithPrefix(fullLogContext).error(`finished runStep with error:`, error);
                                console.log("finished runstep with a failure", error);
                                reject(error);
                            });
                        }
                    });
                };
                processNext();
            }
            catch (error) {
                _1.RunnerOperations.DeployLogWithPrefix(fullLogContext).error(`deploy error in runSteps:${error}`);
                console.error('deploy error runSteps: ', error);
            }
        });
    };
    const runWorkspaces = (lastCommit) => {
        _1.RunnerOperations.DeployLogWithPrefix(fullLogContext).info(`deploying workspaces, last commit:${lastCommit}`);
        console.log("deploying workspaces");
        return _1.Workspaces.updateWorkspaceDeploy(firebase, teamID, runDetails.toWorkspaceID, reduxStore.getState().workspaces.workspaces, lastCommit);
    };
    const runSaveSubgraphs = () => {
        _1.RunnerOperations.DeployLogWithPrefix(fullLogContext).info(`deploying subgraphs`, Object.keys(runDetails.fromWorkspaceData.folders));
        const allSavedSubgraphs = Object.keys(runDetails.fromWorkspaceData.folders).map(subgraphID => {
            const subgraphData = runDetails.fromWorkspaceData.folders[subgraphID];
            return _1.Workspaces.setSubgraphAdmin(firebase, teamID, runDetails.toWorkspaceID, subgraphID, subgraphData);
        });
        return Promise.all(allSavedSubgraphs);
    };
    const runSaveJobs = () => {
        _1.RunnerOperations.DeployLogWithPrefix(fullLogContext).info(`deploying jobs`, Object.keys(runDetails.fromWorkspaceData.jobs));
        const allSavedSubgraphs = Object.keys(runDetails.fromWorkspaceData.jobs).map(jobID => {
            const jobData = runDetails.fromWorkspaceData.jobs[jobID];
            return _1.Workspaces.setCollectionDocumentAdmin(firebase, teamID, runDetails.toWorkspaceID, "jobs", jobID, jobData);
        });
        return Promise.all(allSavedSubgraphs);
    };
    const runSaveMacros = () => {
        _1.RunnerOperations.DeployLogWithPrefix(fullLogContext).info(`deploying macros`, Object.keys(runDetails.fromWorkspaceData.macros));
        const allSavedMacros = Object.keys(runDetails.fromWorkspaceData.macros).map(macroID => {
            const macroData = runDetails.fromWorkspaceData.macros[macroID];
            return _1.Workspaces.setCollectionDocumentAdmin(firebase, teamID, runDetails.toWorkspaceID, "macros", macroID, macroData);
        });
        return Promise.all(allSavedMacros);
    };
    const runSaveStepTypes = () => {
        _1.RunnerOperations.DeployLogWithPrefix(fullLogContext).info(`deploying step types`, runDetails.fromWorkspaceData.stepTypes);
        const allSavedStepTypes = Object.keys(runDetails.fromWorkspaceData.stepTypes).map(stepTypeID => {
            const stepTypeData = runDetails.fromWorkspaceData.stepTypes[stepTypeID];
            return _1.Workspaces.setCollectionDocumentAdmin(firebase, teamID, runDetails.toWorkspaceID, "templates", stepTypeID, stepTypeData);
        });
        return Promise.all(allSavedStepTypes);
    };
    const runSavePackages = () => {
        const packagesSafe = Common.getValueSafe(runDetails.fromWorkspaceData, ["packages"], {});
        _1.RunnerOperations.DeployLogWithPrefix(fullLogContext).info(`deploying packages`, packagesSafe);
        const allSavedPackages = Object.keys(packagesSafe).map(packageID => {
            const packageData = packagesSafe[packageID];
            return _1.Workspaces.setCollectionDocumentAdmin(firebase, teamID, runDetails.toWorkspaceID, "packages", packageID, packageData);
        });
        return Promise.all(allSavedPackages);
    };
    const runSaveProjects = () => {
        const projectsSafe = Common.getValueSafe(runDetails.fromWorkspaceData, ["projects"], {});
        _1.RunnerOperations.DeployLogWithPrefix(fullLogContext).info(`deploying projects`, projectsSafe);
        const allSavedProjects = Object.keys(projectsSafe).map(projectID => {
            const projectData = projectsSafe[projectID];
            return _1.Workspaces.setCollectionDocumentAdmin(firebase, teamID, runDetails.toWorkspaceID, "projects", projectID, projectData);
        });
        return Promise.all(allSavedProjects);
    };
    // run all the different edit types, in order: delete, edit, add
    /**
     * Order of Operations should not be changed and here is why :)
     * Corner case 1:  I want to delete a table and add or alter a table using the same name,
     * if I add the table first with a provision/alter statement, and then run the delete table using runSteps, you will delete the table you just created.
     * Corner case 2: I alter my table name to something new, but then create a new table using the original name,
     *  I need to make sure I don't make the new table first, otherwise instead of having two distinct tables,
     * I'll have one table, misnamed with columns I don't expect and a missing table.
     * ^^^^ This is why we do delete, alter, add :)
     * Why we run runWorkspaces after running our Node edits:
     * The reason we save the new mappings to the workspace after successfully completing the first 3 steps is
     * that we run the risk of lossing data/being unable to run the same deploy again if something goes wrong.
     *
     */
    return runSteps(dividedStepDataWithWorkspaceEdits.deletedTable, true)
        .then(() => runSteps(dividedStepDataWithWorkspaceEdits.alteredTable, false))
        .then(() => runSteps(dividedStepDataWithWorkspaceEdits.addedTable, false))
        .then(() => runWorkspaces(runDetails.deployCommit))
        .then(runSaveSubgraphs)
        .then(runSaveJobs)
        .then(runSaveMacros)
        .then(runSaveStepTypes)
        .then(runSaveProjects)
        .then(runSavePackages)
        .then(() => {
        _1.RunnerOperations.DeployLogWithPrefix(fullLogContext).info("completed deployment");
    })
        .catch(error => {
        var _a;
        _1.RunnerOperations.DeployLogWithPrefix(fullLogContext).error(`deploy error in runDeploy:`, (_a = error === null || error === void 0 ? void 0 : error.error) === null || _a === void 0 ? void 0 : _a.errorString, error.message, error.stack, error);
        throw error;
    });
};
exports.runDeploy = runDeploy;
const getOnRunResult = (reduxStore, firebase, teamID, runCounter) => {
    const fullLogContext = {
        logContext: { orgID: teamID },
        runCounter
    };
    _1.RunnerOperations.DeployLogWithPrefix(fullLogContext).info(`onRunResult args,
        reduxStore:`, _1.RunnerOperations.GetSecureCopyForLog(reduxStore), `firebase:${firebase.name},
        teamID:${teamID},
        runCounter:${runCounter}`);
    //update the runInfo with the result
    return (stepCounter, updateType) => {
        _1.RunnerOperations.DeployLogWithPrefix(fullLogContext).info(`onRunResult trimmed args,
            firebase:${firebase.name},
            stepCounter:${stepCounter},
            runCounter:${runCounter},
            updateType:${updateType}`);
        if (updateType == Runner.ERunResultUpdateType.start) {
            return (0, exports.addToRunHistory)(firebase, teamID, runCounter, stepCounter);
        }
        else {
            console.assert(updateType == Runner.ERunResultUpdateType.update);
            _1.RunnerOperations.DeployLogWithPrefix(fullLogContext).info(`onRunResult run result to update:`, reduxStore.getState().runResults[stepCounter]);
            return (0, exports.updateRunResult)(firebase.firestore(), teamID, runCounter, stepCounter, reduxStore.getState().runResults[stepCounter]);
        }
    };
};
exports.getOnRunResult = getOnRunResult;
const GetAllStepsForJob = (steps, stepCounters) => {
    const jobSteps = new Set();
    const allEdges = GraphOperations.getEdgesLookup(steps);
    stepCounters.forEach(stepCounter => {
        const predecessors = GraphOperations.getPredecessorSteps(allEdges, stepCounter);
        _1.Steps.forAllSteps(predecessors, (stepCounter, stepData) => {
            jobSteps.add(stepCounter);
        });
        jobSteps.add(stepCounter);
    });
    return Array.from(jobSteps);
};
exports.GetAllStepsForJob = GetAllStepsForJob;
/*
 * this function assumes that the jobID, if provided always exists, since it is called from runRefresh which has a
 * strict check before it is called to ensure that if a job doesn't exist a 400 error is sent back
 */
const GetJobDetails = (allWorkspaceData, jobID) => {
    if (!jobID) {
        return null;
    }
    const { jobs, folders, steps } = allWorkspaceData;
    const currentJob = jobs[jobID];
    const stepsInJob = _1.JobOperations.getAllStepsForJob(currentJob, folders);
    return (0, exports.GetAllStepsForJob)(steps, stepsInJob);
};
const DetermineStepsInRunFromJobIDOrSearchSelector = (runDetails, allWorkspaceData) => {
    let stepsForRefresh = null;
    if (runDetails.jobID) {
        stepsForRefresh = GetJobDetails(allWorkspaceData, runDetails.jobID);
    }
    else if (runDetails.includeNodesSelector || runDetails.excludeNodesSelector) {
        stepsForRefresh = Search.GetNodesForRefreshJobFromSearchResult(runDetails.includeNodesSelector || "", runDetails.excludeNodesSelector || "", allWorkspaceData.steps);
    }
    return stepsForRefresh;
};
const runRefresh = (firebase, teamInfo, runCounter, runInfo, environmentID, RunSQL, connection, userContext) => {
    const { fbTeamID: teamID, fbUserID: userID } = teamInfo;
    const fullLogContext = {
        logContext: {
            orgID: teamID,
            userID: userID,
            envID: environmentID,
        },
        runCounter
    };
    return new Promise((resolve, reject) => {
        return _1.Workspaces.getAllWorkspaceDataFromFirebase(firebase.firestore(), teamID, parseInt(environmentID))
            .then((allWorkspaceData) => {
            allWorkspaceData.userConnections[environmentID][userID] = connection;
            // oportunity to calculate the number of steps to run in the process here, so we can provide more feedback to the user
            const stepsInRun = Object.keys(allWorkspaceData.steps).length;
            const runDetails = runInfo.runDetails;
            const stepsForRefresh = DetermineStepsInRunFromJobIDOrSearchSelector(runDetails, allWorkspaceData);
            //oportunity to calculate the number of steps to run in the process here, so we can provide more feedback to the user
            const reduxStore = (0, exports.createReduxStore)(firebase.firestore, allWorkspaceData, runInfo.userCredentials, teamInfo, parseInt(environmentID), null);
            // modify updateRun to allow different aspects of runInfo to be changed, not just one or all as I currently have the typing
            (0, exports.updateRun)(firebase.firestore(), teamID, runCounter, { runDetails: { stepsInRun: stepsInRun } });
            /**
             * we need to specify a different executor for refreshes - this executor takes a firebaseUpdateCB and initializeRunCB as params
             * to track the run information properly in firebase
             */
            const initializeRunCB = (stepID) => (0, exports.addToRunHistory)(firebase, teamID, runCounter, stepID);
            const firebaseUpdateCB = (stepID) => (0, exports.updateRunResult)(firebase.firestore(), teamID, runCounter, stepID, reduxStore.getState().runResults[stepID]);
            const runtimeParametersString = JSON.stringify(runInfo.runTimeParameters);
            const refreshExecutorFactory = (templateString, currentState, specifiedIndex, stepID, isPreview, RunSQL, runtimeParametersString) => {
                return RunStepHelpers.GetRefreshExecutor(templateString, currentState, specifiedIndex, stepID, isPreview, firebaseUpdateCB, initializeRunCB, RunSQL, userContext, runtimeParametersString);
            };
            return reduxStore.dispatch(Runner.PlayTaskThunk(true, stepsForRefresh, refreshExecutorFactory, _1.RunnerOperations.OperationTypes.run, RunSQL, false, runtimeParametersString))
                .then(() => {
                _1.RunnerOperations.DeployLogWithPrefix(fullLogContext).info("completed PlayTaskThunk");
                resolve();
            });
        }).catch((error) => {
            _1.RunnerOperations.DeployLogWithPrefix(fullLogContext).error(`runRefresh error:`, error);
            reject(error);
        });
    });
};
exports.runRefresh = runRefresh;
const getAccessToken = () => {
    return new Promise((resolve, reject) => {
        var _a;
        (_a = _1.Firebase.getFirebaseAuth().currentUser) === null || _a === void 0 ? void 0 : _a.getIdToken().then((idToken) => {
            const createCustomTokenFunc = _1.Firebase.getFunctions().httpsCallable('createCustomToken');
            const payload = { token: idToken };
            console.log("using payload", payload);
            createCustomTokenFunc(payload).then((result) => {
                console.log("got result", result.data);
                const customToken = result.data.customToekn;
                resolve(result.data.refreshToken);
            });
        });
    });
};
exports.getAccessToken = getAccessToken;
//# sourceMappingURL=Runs.js.map